/* irlock - v1
 * Lock the tivo remote control serial port (ttyS0) and run the given
 * command.
 * Tim Kleingeld. Sep 2004.
 */

#include <sys/socket.h>
#include <sys/un.h>
#include <signal.h>

int debug;

main(int argc, char **argv)
{
	struct sockaddr_un addr;
	char buf[1024];
	int sock = socket(PF_UNIX, SOCK_STREAM, 0);
	int pid;
	int status;
	int b;
	if (!strcmp(argv[1], "-d")) {
		argv++;
		debug = 1;
	}

	addr.sun_family=AF_UNIX;
	strcpy(addr.sun_path, "/var/tmp/SerialPortArbitrator");
	if (connect(sock, &addr, sizeof addr) < 0) {
		perror("Failed to connect");
		exit(1);
	}
	if (debug) printf("Sending reqst...\n");
	b = write(sock, "reqst", 5);
	*buf = 0;
	if (debug) printf("Wrote %d bytes. Reading...\n", b);
	b = read(sock, &buf, 5);
	if (b > 0) {
		buf[b] = 0;
	}
	if (debug) printf("Read %d bytes. String '%s'\n", b, buf);
	pid = fork();
	if (pid < 0) {
		perror("fork");
	} else if (!pid) {
		close(sock);
		execv(argv[1], &argv[1]);
		perror("Unable to run requested command!");
		exit(1);
	}
	signal(SIGINT, SIG_IGN);
	wait(&status);
	if (debug) printf("Command %s exitted with status %d\n", argv[1], status);
#if 0
	b = write(sock, "yield", 5);
	printf("Send %d bytes 'yield'\n", b);
	b = read(sock, &buf, 5);
	if (b > 0) {
		buf[b] = 0;
	}
	printf("Read %d bytes. String '%s'\n", b, buf);
	printf("Sending reqst...\n");
	b = write(sock, "reqst", 5);
	*buf = 0;
	printf("Wrote %d bytes. Reading...\n", b);
	b = read(sock, &buf, 5);
	if (b > 0) {
		buf[b] = 0;
	}
	printf("Read %d bytes. String '%s'\n", b, buf);
#endif
	if (debug) printf("Sending done...\n");
	b = write(sock, "done.", 5);
	if (debug) printf("Wrote %d bytes. Closing...\n", b);
	close(sock);
}
