## Process args
set file [lindex $argv 0]
set frequency [lindex $argv 1]
set dataLines [lindex $argv 2]

### Read the file
set fid [open $file]
set content [read $fid]
close $fid

## Split into records on newlines
set records [split $content "\n"]

## Iterate over the records
set wrapCount 0
set rowCount 0
set fldCount 0
foreach rec $records {

   set start [string range $rec 0 4]
   set micro "Micro"
   set len [string length $rec]
   if {$start != $micro && $len>20} { 
   
      ## Split into fields on colons
      set fields [split $rec " "]

      foreach field $fields {
   
	   set triplet [split $field "."]
           set num [lindex $triplet 0]
	   if {$num > 0} {
		set num [expr $num * 3]
		if {$rowCount == 0} {
		   lappend sum $num
		} else {
                   set fldsum [lindex $sum $fldCount]
		   set fldsum [expr $fldsum + $num]
		   set sum [lreplace $sum $fldCount $fldCount $fldsum]
		}		
	   	incr fldCount 1
	   }
      }
      incr wrapCount 1
      if {$wrapCount == $dataLines} {
	set wrapCount 0
	set fldCount 0
	incr rowCount 1
      }
   }
}
### Output the result
set ll [llength $sum]
puts -nonewline "0 $frequency [expr $ll/2] 0 " 
foreach val $sum {
	set outval [expr $val/$rowCount]
	puts -nonewline "$outval "
}
puts ""
